Gyoto::Astrobj::Jet Class Referenceabstract

Simple jet model with thermal or kappa-distribution synchrotron emission from Pandya et al. (2016). More...

`#include <GyotoJet.h>`

Inheritance diagram for Gyoto::Astrobj::Jet:

## Public Types

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > | Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)
| A subcontractor builds an object upon order from the Factory.

## Public Member Functions

virtual Property const * | getProperties () const
| Get list of properties.
| Jet ()
| Standard constructor.
| Jet (const Jet &)
| Copy constructor.
virtual Jet * | clone () const
| Cloner.
virtual | ~Jet ()
| Destructor.
void | jetOuterOpeningAngle (double ang)
double | jetOuterOpeningAngle () const
void | jetInnerOpeningAngle (double ang)
double | jetInnerOpeningAngle () const
void | jetBaseHeight (double hh)
double | jetBaseHeight () const
void | gammaJet (double gam)
double | gammaJet () const
void | jetVphiOverVr (double alpha)
double | jetVphiOverVr () const
double | baseNumberDensity () const
double | baseNumberDensity (std::string const &unit) const
void | baseNumberDensity (double ne)
void | baseNumberDensity (double dens, std::string const &unit)
void | baseTemperature (double tt)
double | baseTemperature () const
void | temperatureSlope (double ss)
double | temperatureSlope () const
void | magnetizationParameter (double rr)
double | magnetizationParameter () const
void | kappaIndex (double index)
double | kappaIndex () const
virtual void | metric (SmartPointer< Metric::Generic >)
| Set the Metric gg_.
virtual double | operator() (double const coord[4])
| Function defining the object interior.
virtual void | radiativeQ (double Inu[], double Taunu[], double const nu_em[], size_t nbnu, double dsem, state_t const &coord_ph, double const coord_obj[8]=NULL) const
| emission and transmission together
virtual void | getVelocity (double const pos[4], double vel[4])
| Fluid velocity field.
virtual SmartPointer< Metric::Generic > | metric () const
| Get the Metric gg_.
virtual void | safetyValue (double val)
| Set Standard::safety_value_.
virtual double | safetyValue () const
| Get Standard::safety_value_.
double | deltaInObj () const
| Get Generic::delta_inobj_.
void | deltaInObj (double val)
| Set Generic::delta_inobj_.
virtual int | Impact (Gyoto::Photon *ph, size_t index, Astrobj::Properties *data=NULL)
| Does a photon at these coordinates impact the object?
virtual double | operator() (double const data[])=0
| The actual function.
virtual double | giveDelta (double coord[8])
| Maximum δ inside object.
virtual double | rMax ()
| Get maximal distance from center of coordinate system.
virtual double | rMax () const
| Get maximal distance from center of coordinate system.
virtual double | rMax (std::string const &unit)
| Get rmax_ is specified unit.
virtual double | rMax (std::string const &unit) const
| Get rmax_ is specified unit.
virtual void | rMax (double val)
| Set maximal distance from center of coordinate system.
virtual void | rMax (double val, std::string const &unit)
| Set maximal distance from center of coordinate system.
virtual double | deltaMax (double coord[8])
| Get max step constraint for adaptive integration.
| GYOTO_OBJECT_ACCESSORS_UNIT (deltaMaxInsideRMax)
void | opticallyThin (bool flag)
| Set whether the object is optically thin.
bool | opticallyThin () const
| Query whether object is optically thin.
void | showshadow (bool flag)
bool | showshadow () const
void | redshift (bool flag)
bool | redshift () const
virtual Gyoto::Quantity_t | getDefaultQuantities ()
| Which quantities to compute if know was requested.
virtual void | setParameters (FactoryMessenger *fmp)
| Main loop in Subcontractor_t function.
virtual void | processHitQuantities (Photon *ph, state_t const &coord_ph_hit, double const *coord_obj_hit, double dt, Astrobj::Properties *data) const
| Fills Astrobj::Properties.
virtual void | processHitQuantities (Photon *ph, double *coord_ph_hit, double *coord_obj_hit, double dt, Astrobj::Properties *data) const =delete
virtual double | emission (double nu_em, double dsem, state_t const &coord_ph, double const coord_obj[8]=NULL) const
| Specific intensity Iν.
virtual double | emission (double nu_em, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const =delete
| Obsolete, update your code;.
virtual void | emission (double Inu[], double const nu_em[], size_t nbnu, double dsem, state_t const &coord_ph, double const coord_obj[8]=NULL) const
| Specific intensity Iν for several values of νem.
virtual void | emission (double Inu[], double nu_em[], size_t nbnu, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const =delete
| Obsolete, update your code.
virtual void | radiativeQ (double Inu[], double Taunu[], double nu_em[], size_t nbnu, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const =delete
virtual void | radiativeQ (double *Inu, double *Qnu, double *Unu, double *Vnu, Eigen::Matrix4d *Onu, double const *nuem, size_t nbnu, double dsem, state_t const &cph, double const *co) const
| Compute the increment of Stokes parameters and transmission matrix. Polarised version of RadiaveQ.
virtual double | integrateEmission (double nu1, double nu2, double dsem, state_t const &c_ph, double const c_obj[8]=NULL) const
| ∫ν1ν2 Iν dν (or jν)
virtual double | integrateEmission (double nu1, double nu2, double dsem, double c_ph[8], double c_obj[8]=NULL) const =delete
| Obsolete, update your code.
virtual void | integrateEmission (double *I, double const *boundaries, size_t const *chaninds, size_t nbnu, double dsem, state_t const &cph, double const *co) const
| ∫ν1ν2 Iν dν (or jν)
virtual void | integrateEmission (double *I, double const *boundaries, size_t const *chaninds, size_t nbnu, double dsem, double *cph, double *co) const =delete
| Obsolete, update your code.
virtual double | transmission (double nuem, double dsem, state_t const &coord_ph, double const coord_obj[8]) const
| Transmission: exp( αν * dsem ).
virtual double | transmission (double nuem, double dsem, state_t const &coord) const =delete
| Obsolete, update your code.
virtual double | transmission (double nuem, double dsem, double coord[8]) const =delete
| Obsolete, update your code.
Eigen::Matrix4d | Omatrix (double alphanu[4], double rnu[3], double Chi, double dsem) const
Eigen::Matrix4d | Omatrix (double alphaInu, double alphaQnu, double alphaUnu, double alphaVnu, double rQnu, double rUnu, double rVnu, double Chi, double dsem) const
Eigen::Matrix4d | Omatrix (double alphanu[4], double rnu[3], double sin2Chi, double cos2Chi, double dsem) const
Eigen::Matrix4d | Omatrix (double alphaInu, double alphaQnu, double alphaUnu, double alphaVnu, double rQnu, double rUnu, double rVnu, double sin2Chi, double cos2Chi, double dsem) const
Eigen::Matrix4d | Pmatrix (double alphaInu, double alphaQnu, double alphaUnu, double alphaVnu, double rQnu, double rUnu, double rVnu, double sin2Chi, double cos2Chi, double dsem) const
Eigen::Vector4d | rotateJs (double jInu, double jQnu, double jUnu, double jVnu, double sin2Chi, double cos2Chi) const
Eigen::Vector4d | rotateJs (double jInu, double jQnu, double jUnu, double jVnu, double Chi) const
double | getChi (double const fourvect[4], state_t const &cph, double const vel[4], bool elec=false) const
void | getSinCos2Chi (double const fourvect[4], state_t const &cph, double const vel[4], double *sin2Chi, double *cos2Chi, bool elec=false) const
void | computeB4vect (double B4vect[4], std::string const magneticConfig, double const co[8], state_t const &cph) const
void | computeB4vect_ipole (double B4vect[4], std::string const magneticConfig, double const co[8], state_t const &cph, double spin) const
double | interpolate (int const N, double *const array, double *const Xq, double **const X, int *const X_params, std::string const *cond_limits) const
double | interpolate (int const N, double *const array, double *const Xq, double **const X_params, std::string const *cond_limits) const
void | incRefCount ()
| Increment the reference counter. Warning: Don't mess with the counter.
int | decRefCount ()
| Decrement the reference counter and return current value. Warning: Don't mess with the counter.
int | getRefCount ()
| Get the current number of references.
virtual bool | isThreadSafe () const
| Whether this class is thread-safe.
virtual void | set (Property const &p, Value val)
| Set Value of a Property.
virtual void | set (Property const &p, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual void | set (std::string const &pname, Value val)
| Set Value of a Property.
virtual void | set (std::string const &pname, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual Value | get (Property const &p) const
| Get Value of a Property.
virtual Value | get (std::string const &pname) const
| Get Value of a Property.
virtual Value | get (Property const &p, std::string const &unit) const
| Get Value of a Property, converted to unit.
virtual Value | get (std::string const &pname, std::string const &unit) const
| Get Value of a Property, converted to unit.
Property const * | property (std::string const pname) const
| Find property by name.
virtual void | fillProperty (Gyoto::FactoryMessenger *fmp, Property const &p) const
| Output a single Property to XML.
virtual void | fillElement (Gyoto::FactoryMessenger *fmp) const
| Fill the XML element for this Object.
virtual int | setParameter (std::string name, std::string content, std::string unit)
| Set parameter by name.
virtual void | setParameter (Gyoto::Property const &p, std::string const &name, std::string const &content, std::string const &unit)
| Set parameter by Property (and name).
std::string | describeProperty (Gyoto::Property const &p) const
| Format desrciption for a property.
void | help () const
| Print (to stdout) some help on this class.
virtual std::string | kind () const
| Get kind_.

## Public Attributes

| GYOTO_OBJECT_THREAD_SAFETY

## Static Public Attributes

static GYOTO_OBJECT Property const | properties []

## Protected Member Functions

virtual void | kind (const std::string)
| Set kind_.
virtual void | tell (Gyoto::Hook::Teller *msg)
| This is how a Teller tells.

## Protected Attributes

double | critical_value_
| See operator()(double const coord[4]).
double | safety_value_
| See operator()(double const coord[4]).
double | delta_inobj_
| Constant value of the integration step inside object, in units of the compact object's mass M.
SmartPointer< Gyoto::Metric::Generic > | gg_
| The Metric in this end of the Universe.
double | rmax_
| Maximum distance to the center of the coordinate system [geometrical units].
double | deltamaxinsidermax_
| Maximum Photon integration step inside rmax_ [geometrical units].
bool | flag_radtransf_
| 1 if radiative transfer inside Astrobj, else 0
int | shadow_
| 1 to highlight the shadow region in the image
int | noredshift_
| 1 to impose redshift factor g = 1
std::string | kind_
| The "kind" that is output in the XML entity.
std::vector< std::string > | plugins_
| The plug-ins that needs to be loaded to access this instance's class.

## Private Member Functions

double | interp1d (double const x, double const y0, double const y1) const
double | interpNd (int const N, double *const Xq, double **const X, double *const Y, std::string const *cond_limit) const
int | getIndice (double &xq, std::string const cond_limit, double const X_params[3], double *const X=NULL) const

## Private Attributes

SmartPointer< Spectrum::KappaDistributionSynchrotron > | spectrumKappaSynch_
SmartPointer< Spectrum::ThermalSynchrotron > | spectrumThermalSynch_
double | jetOuterOpeningAngle_
| Jet outer opening angle (rad).
double | jetInnerOpeningAngle_
| Jet inner opening angle (rad).
double | jetBaseHeight_
| Height of the base of the jet (z value, M units).
double | gammaJet_
| Constant Lorentz factor in jet.
double | jetVphiOverVr_
| this is (r*Vphi/Vr) where V is the jet velocity measured by the ZAMO
double | baseNumberDensity_cgs_
| electron nb density at jet base (cgs)
double | baseTemperature_
| electron temperature at jet base (K)
double | temperatureSlope_
| electron temperature \propto z^temperatureSlope_
double | magnetizationParameter_
| Pmagn/(ne mp c2).
int | __defaultfeatures
| Whether some virtual methods are implemented.
int | refCount
| Reference counter.
pthread_mutex_t | mutex_
| A mutex.

## Friends

class | Gyoto::SmartPointer< Gyoto::Astrobj::Jet >

## Detailed Description

Simple jet model with thermal or kappa-distribution synchrotron emission from Pandya et al. (2016).

This class implements a jet defined as the volume contained between the two conical surfaces defined by angles jetInnerOpeningAngle_ and jetOuterOpeningAngle_, with apex located on the black hole rotation axis at altitude jetBaseHeight_ in units of M.

The Lorentz factor is assumed constant at gammaJet_. The electron number density at the base of the jet is baseNumberDensity_cgs_, its z-evolution is dedictated by mass conservation. The electron temperature is baseTemperature_, its z-evolution is assumed to follow a power law z^temperatureSlope_. The magnetic field amplitude is defined by the magnetization parameter, magnetizationParameter_.

The jet emits synchrotron radiation, assuming that the electrons follow a thermal or kappa distribution, ie the smooth gluing of a thermal distribution at low electron Lorentz factor, to a power-law distribution at high electron Lorentz factor. This distribution, as well as the resulting emission and absorption coefficients are taken from: Pandya et al., ApJ, 822, 34 (2016), section 5.3.3

## Member Typedef Documentation

## Subcontractor_t

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > Gyoto::SmartPointee::Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)

inherited

A subcontractor builds an object upon order from the Factory.

Various classes need to provide a subcontractor to be able to instantiate themselves upon order from the Factory. A subcontractor is a function (often a static member function) which accepts a pointer to a FactoryMessenger as unique parameter, communicates with the Factory using this messenger to read an XML description of the object to build, and returns this objet. SmartPointee::Subcontractor_t* is just generic enough a typedef to cast to and from other subcontractor types: Astrobj::Subcontractor_t, Metric::Subcontractor_t, Spectrum::Subcontractor_t. A subcontractor needs to be registered using the relevant Register() function: Astrobj::Register(), Metric::Register(), Spectrum::Register().

## Member Function Documentation

## clone()

virtual Jet * Gyoto::Astrobj::Jet::clone | ( |  | ) | const

virtual

Cloner.

Implements Gyoto::Astrobj::Generic.

## computeB4vect()

void Gyoto::Astrobj::Generic::computeB4vect | ( | double | B4vect[4],
|  | std::string const | magneticConfig,
|  | double const | co[8],
|  | state_t const & | cph ) const

inherited

Compute the magnetic field 4-vector at a given position and a given configuration

Parameters

  B4vect | the output 4-vector magnetic field
  magneticConfig | string which determine the wanted configuration ('Radial', 'Azimuthal', 'Vertical')
  co | coordinate of the object which also contain its velocity
  cph | coordinate of the photon

## deltaInObj()

double Gyoto::Astrobj::Standard::deltaInObj | ( |  | ) | const

inherited

Get Generic::delta_inobj_.

Get the constant integration step inside the astrobj

Returns
  delta_inobj_ in geometrical units

## deltaMax()

virtual double Gyoto::Astrobj::Generic::deltaMax | ( | double | coord[8] | ) |

virtual inherited

Get max step constraint for adaptive integration.

Parameters

  [in] | coord | position

Returns
  max step to find this object reliably

Reimplemented in Gyoto::Astrobj::Complex, and Gyoto::Astrobj::EquatorialHotSpot.

## describeProperty()

std::string Gyoto::Object::describeProperty | ( | Gyoto::Property const & | p | ) | const

inherited

Format desrciption for a property.

Returns a string containing the name(s) and type of the property, as well as whether it supports unit.

## emission() [1/2]

virtual void Gyoto::Astrobj::Generic::emission | ( | double | Inu[],
|  | double const | nu_em[],
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | coord_ph,
|  | double const | coord_obj[8] = NULL ) const

virtual inherited

Specific intensity Iν for several values of νem.

Called by the default implementation for processHitQuantities().

emission() computes the intensity Iν emitted by the small volume of length dsem. It should take self-absorption along dsem into account.

Same as emission(double nu_em, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const looping on several values of nu_em.

Parameters

  Inu[nbnu] | Output (must be set to a previously allocated array of doubles)
  nu_em[nbnu] | Frequencies at emission
  nbnu | Size of Inu[] and nu_em[]
  dsem | Length over which to integrate inside the object
  coord_ph | Photon coordinate
  coord_obj | Emitter coordinate at current photon position

Returns
  Iν or dIν [W m-2 sr-2]

Reimplemented in Gyoto::Astrobj::Python::Standard, and Gyoto::Astrobj::Python::ThinDisk.

## emission() [2/2]

virtual double Gyoto::Astrobj::Generic::emission | ( | double | nu_em,
|  | double | dsem,
|  | state_t const & | coord_ph,
|  | double const | coord_obj[8] = NULL ) const

virtual inherited

Specific intensity Iν.

Called by the default implementation for processHitQuantities().

emission() computes the intensity Iν emitted by the small volume of length dsem, in the emitter's frame. It should take self-absorption along dsem into account.

Reminder :

- intensity = Iν [J m^-2 s^-1 ster^-1 Hz^-1];
- invariant intensity = Iν/ν3, which has the same value in any frame;
- emission coefficient = jν [J m^-3 s^-1 ster^-1 Hz^-1] , defined by dIν = jν*ds, where ds is the distance travelled by the photon inside the object;
- invariant emission coef = jν/ν2, which has the same value in any frame.

The equation used for radiative transfer (without absorption) is:

d(Iν/ν3)/dλ = (jν/ν2) [*]

where λ is the integration parameter along the null geodesic.

NB: Let us consider a particular observer, with ν being the frequency measured by this observer, and ds being the proper distance (as measured by the observer) that the photon travels as it moves from λ to λ+dλ along its geodesic. Then it can be shown that:

dλ = ds/ν

This shows that Eq. [*] is homogeneous.

The default implementation returns 1. if optically thick and dsem if optically thin. It allows for a quick implementation of your object for visualization purposes.

Parameters

  nu_em | Frequency at emission [Hz]
  dsem | length over which to integrate inside the object [geometrical units]
  coord_ph | Photon coordinate
  coord_obj | Emitter coordinate at current photon position

Reimplemented in Gyoto::Astrobj::DirectionalDisk, Gyoto::Astrobj::DynamicalDisk3D, Gyoto::Astrobj::DynamicalDisk, Gyoto::Astrobj::DynamicalDiskBolometric, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::InflateStar, Gyoto::Astrobj::NeutronStarAnalyticEmission, Gyoto::Astrobj::NeutronStarModelAtmosphere, Gyoto::Astrobj::PageThorneDisk, Gyoto::Astrobj::PatternDisk, Gyoto::Astrobj::PatternDiskBB, Gyoto::Astrobj::Python::Standard, Gyoto::Astrobj::Python::ThinDisk, Gyoto::Astrobj::ThinDiskGridIntensity, Gyoto::Astrobj::ThinDiskIronLine, Gyoto::Astrobj::ThinDiskPL, Gyoto::Astrobj::ThinDiskProfile, Gyoto::Astrobj::Torus, Gyoto::Astrobj::UniformSphere, and Gyoto::Astrobj::XillverReflection.

## fillElement()

virtual void Gyoto::Object::fillElement | ( | Gyoto::FactoryMessenger * | fmp | ) | const

virtual inherited

Fill the XML element for this Object.

The base implementation simply calls fillProperty() for each Property defined for the Object.

Derived classes should avoid overriding fillElement(). It may make sense occasionally, e.g. to make sure that the metric is output first.

To customize how a given Property is rendered, it is better to override fillProperty().

If this method is overridden, the implementation should in general call fillElement() on the direct base.

Reimplemented in Gyoto::Astrobj::Complex, Gyoto::Metric::Complex, Gyoto::Scenery, and Gyoto::Spectrometer::Complex.

## fillProperty()

virtual void Gyoto::Object::fillProperty | ( | Gyoto::FactoryMessenger * | fmp,
|  | Property const & | p ) const

virtual inherited

Output a single Property to XML.

The base implementation decides what to do based on the p.type. The format matches how setParameters() an setParameter() would interpret the XML descition.

Overriding this method should be avoided, but makes sense in some cases (for instance Screen::fillProperty() selects a different unit for Distance based on its magnitude, so that stellar sizes are expressed in solar radii while smaller sizes can be expressed in meters and larger sizes in parsecs).

Overriding implementation should fall-back on calling the implementation in the direct parent class:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const ;
};
void B::fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const {
if (name=="Duff") fmp->doSomething();
else A::fillProperty(fmp, p);
}
Gyoto::FactoryMessenger
Factory / SmartPointee::Subcontractor_t interface.
Definition GyotoFactoryMessenger.h:92
Gyoto::Object::Object
Object(std::string const &kind)
Constructor setting kind.
Gyoto::Property
Property that can be set and got using standard methods.
Definition GyotoProperty.h:608

Reimplemented in Gyoto::Astrobj::DirectionalDisk, Gyoto::Astrobj::Disk3D, Gyoto::Astrobj::DynamicalDisk, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::NeutronStarModelAtmosphere, Gyoto::Astrobj::PatternDisk, Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::Star, Gyoto::Astrobj::XillverReflection, Gyoto::Metric::Shift, Gyoto::Scenery, Gyoto::Screen, and Gyoto::Spectrometer::Uniform.

## getChi()

double Gyoto::Astrobj::Generic::getChi | ( | double const | fourvect[4],
|  | state_t const & | cph,
|  | double const | vel[4],
|  | bool | elec = false ) const

inherited

Get Chi angle. Return the angle between the parallel transported observer polarization basis (Ephi,Etheta) and the Stokes basis in the rest frame of the emitter defined by the 4-vector magnetic/electric field.

Parameters

  fourvect | 4-vector magnetic/electric field depending on elec (false/true)
  cph | Photon coordinate, must contain the Ephi and Etheta vectors i.e. size(cph)==16
  vel | Fluid velocity at the photon coordinate

## getDefaultQuantities()

virtual Gyoto::Quantity_t Gyoto::Astrobj::Generic::getDefaultQuantities | ( |  | ) |

virtual inherited

Which quantities to compute if know was requested.

Return a Gyoto::Quantity_t suitable as input to Gyoto::Scenery::setRequestedQuantities() to set de default quantities to compute for this object. The default of these defaults GYOTO_QUANTITY_INTENSITY.

Reimplemented in Gyoto::Astrobj::PageThorneDisk.

## getIndice()

int Gyoto::Astrobj::Generic::getIndice | ( | double & | xq,
|  | std::string const | cond_limit,
|  | double const | X_params[3],
|  | double *const | X = NULL ) const

private inherited

Function that return the closest indice of the query value on an axis.

Parameters

  xq | query value on the axis. Could be modified in case of periodic boundary condition.
  cond_limit | boundary conditions that will be applied to the axis.
  X_params[3] | array which contain the minimum value, the maximum value and the length of the axe.
  X | (optional) array which contains the value of the axis points. Usefull for not linearly spaced axis.

## getProperties()

virtual Property const * Gyoto::Astrobj::Jet::getProperties | ( |  | ) | const

virtual

Get list of properties.

This method is declared automatically by the GYOTO_OBJECT macro and defined automatically by the GYOTO_PROPERTY_END macro.

Reimplemented from Gyoto::Astrobj::Standard.

## getSinCos2Chi()

void Gyoto::Astrobj::Generic::getSinCos2Chi | ( | double const | fourvect[4],
|  | state_t const & | cph,
|  | double const | vel[4],
|  | double * | sin2Chi,
|  | double * | cos2Chi,
|  | bool | elec = false ) const

inherited

Get the cosinus and sinus of 2*Chi angle. Chi being the angle between the parallel transported observer polarization basis (Ephi,Etheta) and the Stokes basis in the rest frame of the emitter defined by the 4-vector magnetic/electric field.

Parameters

  fourvect | 4-vector magnetic/electric field depending on elec (false/true)
  cph | Photon coordinate, must contain the Ephi and Etheta vectors i.e. size(cph)==16
  vel | Fluid velocity at the photon coordinate

## getVelocity()

virtual void Gyoto::Astrobj::Jet::getVelocity | ( | double const | pos[4],
|  | double | vel[4] )

virtual

Fluid velocity field.

Fill vel with the 4-vector velocity of the fluid at 4-position pos.

Parameters

  [in] | pos | 4-position at which to compute velocity;
  [out] | vel | 4-velocity at pos.

Implements Gyoto::Astrobj::Standard.

## giveDelta()

virtual double Gyoto::Astrobj::Standard::giveDelta | ( | double | coord[8] | ) |

virtual inherited

Maximum δ inside object.

Gives the requested integration step δt (in coordinate time t) between two neighboring points along a portion of geodesic inside an astrobj; the current implementation only considers a constant delta, equal to Standard::deltaInobj()

Parameters

  coord | input coordinate at which δt is given

Reimplemented in Gyoto::Astrobj::Python::Standard.

## help()

void Gyoto::Object::help | ( |  | ) | const

inherited

Print (to stdout) some help on this class.

Describe all properties that this instance supports.

## Impact()

virtual int Gyoto::Astrobj::Standard::Impact | ( | Gyoto::Photon * | ph,
|  | size_t | index,
|  | Astrobj::Properties * | data = NULL )

virtual inherited

Does a photon at these coordinates impact the object?

Impact() checks whether a Photon impacts the object between two integration steps of the photon's trajectory (those two steps are photon->getCoord(index, coord1) and photon->getCoord(index+1, coord2)). Impact returns 1 if the photon impacts the object between these two steps, else 0. In many cases of geometrically thick obects, the implementation Astrobj::Standard::Impact() will be fine.

Impact will call Generic::processHitQuantities() (which is virtual and may be re-implemented) to compute observable properties on demand: if the data pointer is non-NULL, the object will look in it for pointers to properties which apply to its kind. If a pointer to a property known to this object is present, then the property is computed and store at the pointed-to address. For instance, all objects know the "intensity" property. If data->intensity != NULL, the instensity is computed and stored in *data->intensity.

If data is non-NULL and only in this case, processHitQuantities() will also call ph->transmit() to update the transmissions of the Photon (see Photon::transmit(size_t, double)). This must not be done if data is NULL (see Astrobj::Complex::Impact() for an explanation).

Impact() may not extend the ph Worldline. The only two dates that are guaranteed to be defined are at indices index and index+1.

Parameters

  ph | Gyoto::Photon aimed at the object;
  index | Index of the last photon step;
  data | Pointer to a structure to hold the observables at impact.

Returns
  1 if impact, 0 if not.

Implements Gyoto::Astrobj::Generic.

Reimplemented in Gyoto::Astrobj::InflateStar, Gyoto::Astrobj::Plasmoid, and Gyoto::Astrobj::PolishDoughnut.

## integrateEmission() [1/2]

virtual void Gyoto::Astrobj::Generic::integrateEmission | ( | double * | I,
|  | double const * | boundaries,
|  | size_t const * | chaninds,
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | cph,
|  | double const * | co ) const

virtual inherited

∫ν1ν2 Iν dν (or jν)

Like double integrateEmission(double nu1, double nu2, double dsem, double c_ph[8], double c_obj[8]) const for each Spectrometer channel.

Reimplemented in Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::Python::Standard, and Gyoto::Astrobj::Python::ThinDisk.

## integrateEmission() [2/2]

virtual double Gyoto::Astrobj::Generic::integrateEmission | ( | double | nu1,
|  | double | nu2,
|  | double | dsem,
|  | state_t const & | c_ph,
|  | double const | c_obj[8] = NULL ) const

virtual inherited

∫ν1ν2 Iν dν (or jν)

Compute the integral of emission() from ν1 to ν2. The default implementation is a numerical integrator which works well enough and is reasonably fast if emission() is a smooth function (i.e. no emission or absorption lines). If possible, it is wise to implement an analytical solution. It is used by processHitQuantities to compute the "BinSpectrum" quantity which is the most physical: it is the only quantity that can be actually measured directly by a real-life instrument.

Reimplemented in Gyoto::Astrobj::Python::Standard, Gyoto::Astrobj::Python::ThinDisk, and Gyoto::Astrobj::Torus.

## interp1d()

double Gyoto::Astrobj::Generic::interp1d | ( | double const | x,
|  | double const | y0,
|  | double const | y1 ) const

private inherited

Function which returns the 1D linear interpolation.

Parameters

  x | the x query position along the linear function [0,1].
  y0 | the value of the array to be interpolated at the low position.
  y1 | the value of the array to be interpolated at the high position.

## interpNd()

double Gyoto::Astrobj::Generic::interpNd | ( | int const | N,
|  | double *const | Xq,
|  | double **const | X,
|  | double *const | Y,
|  | std::string const * | cond_limit ) const

private inherited

Function which returns the N- dimension interpolation on an N-dimensional cube

Parameters

  N | number of dimensions
  Xq | query position at which the interpolation should be done. 1D array with N elements.
  X[2**N][N] | 2D array that contains for the 2**N points of the N dimensional cube the associated axes values.
  Y[2**N] | 1D array that contain the value of the array to be interpolated at each points of the N-dimensional cube.
  cond_limit | 1D array of strings that set the boundary conditions that will be applied to each axes.

## interpolate() [1/2]

double Gyoto::Astrobj::Generic::interpolate | ( | int const | N,
|  | double *const | array,
|  | double *const | Xq,
|  | double **const | X,
|  | int *const | X_params,
|  | std::string const * | cond_limits ) const

inherited

N-dimensional linear interpolation function

Parameters

  N | number of dimensions
  array | array that should be interpolated. This array has to be a 1D array with the first dimension evolving the slowest
  Xq | query position at which the interpolation should be done. 1D array with N elements.
  X | 2D array containing the range of all the axes (for example : radius, \theta, \varphi) at which the array is knwon. Should be built as a pointer of pointers.
  X_params | 1D array that contain the length of each axes.
  cond_limits | 1D array of strings that set the boundary conditions that will be applied to each axes

## interpolate() [2/2]

double Gyoto::Astrobj::Generic::interpolate | ( | int const | N,
|  | double *const | array,
|  | double *const | Xq,
|  | double **const | X_params,
|  | std::string const * | cond_limits ) const

inherited

N-dimensional linear interpolation function

Parameters

  N | number of dimensions
  array | array that should be interpolated. This array has to be a 1D array with the first dimension evolving the slowest
  Xq | query position at which the interpolation should be done. 1D array with N elements.
  X_params[N][3] | 2D array that contain the minimum value, the maximum value and the length of each axes. The axes will be assumed to be linearly spaced.
  cond_limits | 1D array of strings that set the boundary conditions that will be applied to each axes.

## isThreadSafe()

virtual bool Gyoto::Object::isThreadSafe | ( |  | ) | const

virtual inherited

Whether this class is thread-safe.

Return True if this object is thread-safe, i.e. if an instance and its clone can be used in parallel threads (in the context of Scenery::raytrace()). Known objects which are not thread-safe include Lorene metrics and everything from the Python plug-in.

The default implementation considers that the class itself is thread safe and recurses into the declared properties to check whether they are safe too. Classes that abide to the Object/Property paradigm and are themselves thread-safe have nothing special to do.

Objects that clone children in their copy constructor that are not declared as properties must take these children into account.

Classes that are never thread-safe must declare it. It acn be easily done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and GYOTO_PROPERTY_THREAD_UNSAFE in the class definition.

## kind() [1/2]

virtual std::string Gyoto::Object::kind | ( |  | ) | const

virtual inherited

Get kind_.

Reimplemented in Gyoto::Spectrometer::Uniform.

## kind() [2/2]

virtual void Gyoto::Object::kind | ( | const std::string |  | ) |

protected virtual inherited

Set kind_.

kind(const std::string) is protected because, for most Objects, it should not be changed in runtime. Set kind_

## metric() [1/2]

virtual SmartPointer< Metric::Generic > Gyoto::Astrobj::Generic::metric | ( |  | ) | const

virtual

Get the Metric gg_.

Reimplemented from Gyoto::Astrobj::Generic.

## metric() [2/2]

virtual void Gyoto::Astrobj::Jet::metric | ( | SmartPointer< Metric::Generic > |  | ) |

virtual

Set the Metric gg_.

Reimplemented from Gyoto::Astrobj::Generic.

## Omatrix()

Eigen::Matrix4d Gyoto::Astrobj::Generic::Omatrix | ( | double | alphanu[4],
|  | double | rnu[3],
|  | double | Chi,
|  | double | dsem ) const

inherited

Omatrix() computes the exponential of the Mueller matrix which contains the absorption and Faraday coefficients and is used in the polarized radiative transfer equation.

Parameters

  Onu | output matrix (must be allocated previously)
  alphanu[4] | array containing the 4 absorption coefficients in the Stokes basis (I,Q,U,V)
  rnu[3] | array containing the 3 Faraday coefficients in the Stokes basis (Q,U,V)
  Chi | angle of rotation between the parallel transported observer polarization basis and the Stokes basis
  dsem | geometrical length in geometrical units

## operator()() [1/2]

virtual double Gyoto::Astrobj::Jet::operator() | ( | double const | coord[4] | ) |

virtual

Function defining the object interior.

A potential, distance, or whatever function such that operator()(double const coord[4]) < Standard::critical_value_ if and only if coord is inside the object. This function is used by the default implmenetation of Impact(). If Impact() is overloaded, it is not necessary to overload operator()(double coord[4]). The default implementation throws an error.

Implements Gyoto::Astrobj::Standard.

## operator()() [2/2]

virtual double Gyoto::Functor::Double_constDoubleArray::operator() | ( | double const | data[] | ) |

pure virtual inherited

The actual function.

Implemented in Gyoto::Astrobj::ThinDisk.

## opticallyThin() [1/2]

bool Gyoto::Astrobj::Generic::opticallyThin | ( |  | ) | const

inherited

Query whether object is optically thin.

See opticallyThin(bool flag).

## opticallyThin() [2/2]

void Gyoto::Astrobj::Generic::opticallyThin | ( | bool | flag | ) |

inherited

Set whether the object is optically thin.

Set flag indicating that radiative transfer should be integrated, i.e. the object is to be considered optically thin.

Parameters

  flag | 1 if optically thin, 0 if optically thick.

## processHitQuantities()

virtual void Gyoto::Astrobj::Generic::processHitQuantities | ( | Photon * | ph,
|  | state_t const & | coord_ph_hit,
|  | double const * | coord_obj_hit,
|  | double | dt,
|  | Astrobj::Properties * | data ) const

virtual inherited

Fills Astrobj::Properties.

processHitQuantities fills the requested data in Impact. To use it, you need to call it in the Impact() method for your object in case of hit. It will fill Redshift, Intensity, Spectrum, BinSpectrum and update the Photon's transmission by calling Photon::transmit(), only if data==NULL.

You can overload it for your Astrobj. The generic implementation calls emission(), integrateEmission() and transmission() below.

Reimplemented in Gyoto::Astrobj::DynamicalDiskBolometric, Gyoto::Astrobj::PageThorneDisk, and Gyoto::Astrobj::ThinDiskProfile.

## property()

Property const * Gyoto::Object::property | ( | std::string const | pname | ) | const

inherited

Find property by name.

Look into the Property list for a Property whose name (or name_false, for a boolean Property) is pname. Return a const pointer to the first such property found, or NULL if none is found.

## radiativeQ() [1/2]

virtual void Gyoto::Astrobj::Generic::radiativeQ | ( | double * | Inu,
|  | double * | Qnu,
|  | double * | Unu,
|  | double * | Vnu,
|  | Eigen::Matrix4d * | Onu,
|  | double const * | nuem,
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | cph,
|  | double const * | co ) const

virtual inherited

Compute the increment of Stokes parameters and transmission matrix. Polarised version of RadiaveQ.

First function to be called for radiative quantities. If exist, i.e. implemented in an Astrobj, return the Stokes parameters emitted by the small volume of length dsem.

Warning :

- The basis used to determine the Stokes coefficients is different from the observer parallel transported polarisation basis. One should use getChi function to compute the angle between these two basis.
- The non polarized case must also be implemented in this function to avoid error.

See example in SimplePolarStar.C.

Parameters

  Inu[nbnu] | Output increment of intensity (must be set to a previously allocated array of doubles)
  Qnu[nbnu] | Output increment of Stokes parameter Q (must be set to a previously allocated array of doubles)
  Unu[nbnu] | Output increment of Stokes parameter U (must be set to a previously allocated array of doubles)
  Vnu[nbnu] | Output increment of Stokes parameter V (must be set to a previously allocated array of doubles)
  Onu[nbnu] | Output transmission (Eigen) matrix (must be set to a previously allocated array of Matrix4d)
  nu_em[nbnu] | Frequencies at emission
  nbnu | Size of nu_em[], Inu[], Qnu[], Unu[], Vnu[], and Onu[]
  dsem | Length over which to integrate inside the object
  cph | Photon coordinate
  co | Emitter coordinate at current photon position

Returns
  Increment of the Stokes parameters (I,Q,U,V) and local Transmission matrix (O).

Reimplemented in Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::PageThorneDisk, Gyoto::Astrobj::Star, and Gyoto::Astrobj::ThickDisk.

## radiativeQ() [2/2]

virtual void Gyoto::Astrobj::Jet::radiativeQ | ( | double | Inu[],
|  | double | Taunu[],
|  | double const | nu_em[],
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | coord_ph,
|  | double const | coord_obj[8] = NULL ) const

virtual

emission and transmission together

Reimplemented from Gyoto::Astrobj::Generic.

## rMax() [1/4]

virtual double Gyoto::Astrobj::Generic::rMax | ( |  | ) |

virtual inherited

Get maximal distance from center of coordinate system.

Get maximal distance from center of coordinate system at which a Photon may hit the object.

Child classes may use the rmax_ member to cache this value, if its current value is DBL_MAX.

It can also be set using rMax().

Returns
  rmax_ in geometrical units

Reimplemented in Gyoto::Astrobj::Complex, Gyoto::Astrobj::FixedStar, Gyoto::Astrobj::Star, and Gyoto::Astrobj::Torus.

## rMax() [2/4]

virtual void Gyoto::Astrobj::Generic::rMax | ( | double | val | ) |

virtual inherited

Set maximal distance from center of coordinate system.

Set maximal distance from center of coordinate system at which a Photon may hit the object.

Parameters

  val | new rmax_ in geometrical units.

## rMax() [3/4]

virtual void Gyoto::Astrobj::Generic::rMax | ( | double | val,
|  | std::string const & | unit )

virtual inherited

Set maximal distance from center of coordinate system.

Call Generic::rMax(double val) after converting val from unit to geometrical units.

Parameters

  val | rmax_ expressed in unit "unit";
  unit | string...

## rMax() [4/4]

virtual double Gyoto::Astrobj::Generic::rMax | ( | std::string const & | unit | ) |

virtual inherited

Get rmax_ is specified unit.

Call rMax() and convert result to unit.

Parameters

  unit | string

Returns
  double rmax converted to unit

## rotateJs()

Eigen::Vector4d Gyoto::Astrobj::Generic::rotateJs | ( | double | jInu,
|  | double | jQnu,
|  | double | jUnu,
|  | double | jVnu,
|  | double | sin2Chi,
|  | double | cos2Chi ) const

inherited

Apply the rotation matrix with angle Chi to the emission Stokes vector constructed in the fonction from the individual coefficients

## setParameter() [1/2]

virtual void Gyoto::Object::setParameter | ( | Gyoto::Property const & | p,
|  | std::string const & | name,
|  | std::string const & | content,
|  | std::string const & | unit )

virtual inherited

Set parameter by Property (and name).

This function is used when parsing an XML description, if Property (p) of this name is found (i.e. either p.name or p.name_false is equal to name). Implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit);
};
void B::setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else A::setParameter(p, name, content, unit);
}

Parameters

  p | Property that matches name (p.name == name or p.name_false == name)
  name | XML name of the parameter (XML entity)
  content | string representation of the value
  unit | string representation of the unit

Reimplemented in Gyoto::Astrobj::PolishDoughnut.

## setParameter() [2/2]

virtual int Gyoto::Object::setParameter | ( | std::string | name,
|  | std::string | content,
|  | std::string | unit )

virtual inherited

Set parameter by name.

This function is used when parsing an XML description, if no Property of this name is found. Overriding implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual int setParameter(std::string name,
std::string content,
std::string unit);
};
int B::setParameter(std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else return A::setParameter(name, content, unit);
return 0; // name was known
}

Parameters

  name | XML name of the parameter (XML entity). This may have a path component, e.g. "Astrobj::Radius", in which case a property named "Astrobj" will be sought in the current object, and setParameter will be called recusrively on this Astrobj with Radius as name.
  content | string representation of the value
  unit | string representation of the unit

Returns
  0 if this parameter is known, 1 if it is not.

Reimplemented in Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::Star, Gyoto::Metric::KerrKS, and Gyoto::Metric::RotStar3_1.

## setParameters()

virtual void Gyoto::Astrobj::Generic::setParameters | ( | FactoryMessenger * | fmp | ) |

virtual inherited

Main loop in Subcontractor_t function.

The Subcontractor_t function for each Astrobj kind should look somewhat like this (templated as Gyoto::Astrobj::Subcontractor<MyKind>):

SmartPointer<Astrobj::Generic>
Gyoto::Astrobj::MyKind::Subcontractor(FactoryMessenger* fmp) {
SmartPointer<MyKind> ao = new MyKind();
ao -> setParameters(fmp);
return ao;
}
Gyoto::Astrobj::Generic::setParameters
virtual void setParameters(FactoryMessenger *fmp)
Main loop in Subcontractor_t function.
Gyoto::SmartPointer
Pointers performing reference counting.
Definition GyotoSmartPointer.h:135

Each object kind should implement setParameter(string name, string content, string unit) to interpret the individual XML elements. setParameters() can be overloaded in case the specific Astrobj class needs low level access to the FactoryMessenger. See UniformSphere::setParameters().

Reimplemented from Gyoto::Object.

Reimplemented in Gyoto::Astrobj::Complex, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::OscilTorus, and Gyoto::Astrobj::Star.

## tell()

virtual void Gyoto::Hook::Listener::tell | ( | Gyoto::Hook::Teller * | msg | ) |

protected virtual inherited

This is how a Teller tells.

A teller will basically call listener->tell(this).

Parameters

  msg | Teller* the Teller who is telling... Useful if the Listener listens to several Tellers.

Reimplemented in Gyoto::Astrobj::OscilTorus, Gyoto::Astrobj::PageThorneDisk, Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::XillverReflection, Gyoto::Metric::Shift, Gyoto::Spectrometer::Complex, and Gyoto::Worldline.

## transmission()

virtual double Gyoto::Astrobj::Generic::transmission | ( | double | nuem,
|  | double | dsem,
|  | state_t const & | coord_ph,
|  | double const | coord_obj[8] ) const

virtual inherited

Transmission: exp( αν * dsem ).

transmission() computes the transmission of this fluid element or 0 if optically thick. The default implementation returns 1. (no attenuation) if optically thin, 0. if optically thick.

Parameters

  nuem | frequency in the fluid's frame
  coord | Photon coordinate
  dsem | geometrical length in geometrical units

Reimplemented in Gyoto::Astrobj::DynamicalDisk3D, and Gyoto::Astrobj::PatternDisk.

## Member Data Documentation

## __defaultfeatures

int Gyoto::Astrobj::Generic::__defaultfeatures

private inherited

Whether some virtual methods are implemented.

The default implementations of some methods call one-another. This member is used internally to avoid infinite recursion.

## deltamaxinsidermax_

double Gyoto::Astrobj::Generic::deltamaxinsidermax_

protected inherited

Maximum Photon integration step inside rmax_ [geometrical units].

Maximum step for Photon integation when inside the sphere of radius rmax_.

deltamaxinsidermax_ is in geometrical units.

## kind_

std::string Gyoto::Object::kind_

protected inherited

The "kind" that is output in the XML entity.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj kind="kind_" ...>...</Astrobj>
Gyoto::Object::kind
virtual void kind(const std::string)
Set kind_.
Gyoto::Astrobj
Access to astronomical objects.
Definition GyotoAstrobj.h:49

is written.

## mutex_

pthread_mutex_t Gyoto::SmartPointee::mutex_

private inherited

A mutex.

When compiled with libpthread

## plugins_

std::vector<std::string> Gyoto::Object::plugins_

protected inherited

The plug-ins that needs to be loaded to access this instance's class.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj ... plugin="plugins_">...</Astrobj>

is written.

## rmax_

double Gyoto::Astrobj::Generic::rmax_

protected inherited

Maximum distance to the center of the coordinate system [geometrical units].

Maximum distance from the center of the coordinate system at which a photon may hit the object. Child classes may compute a decent value for rmax_ at any time if rmax_ is DBL_MAX. External classes (Photons in particular) must use rMax() to access this information.

rmax_ is in geometrical units.

The documentation for this class was generated from the following file:

- GyotoJet.h